/*
 * Parser & Scanner Common Definitions
 */
#ifndef PARSER_H
#define PARSER_H

#include "strpool.h"

extern StrPool string_pool;

/* The type of values associated with terminals and nonterminals */
struct yys {
    const char *name;
    int int_value;
    double double_value;
};

#define YYSTYPE yys

#include "comp.hpp"     /* File generated automatically by bison: */
                        /* contains the definitions of terminals  */

int yylex();              /* Prototype of the scanner function "next lexeme" */
int yyerror(const char*); /* Prototype of the error diagnostics function     */

// Types of lexemes
#define TYPE_INT 0
#define TYPE_DOUBLE 1
#define TYPE_STRING 2

#define RELOP_EQ 0
#define RELOP_NE 1
#define RELOP_GT 2
#define RELOP_GE 3
#define RELOP_LT 4
#define RELOP_LE 5

#endif
